#ifndef _BOARD_H_
#define _BOARD_H_

#include <vector>
#include <iostream>

class Board
{
public:
    enum HoleType { HOUSE, STORE };
    enum Half {UNSPECIFIED, NORTH, SOUTH};

    Board();
    Board(int houses, int seeds);

    int & operator[] (int hole);

    size_t size() const;

    int getSeedsInHouse(int house) const;
    int getSeedsInStore(int store) const;

    int getStoreHole(Half Half) const;
    int getOppositeHole(int hole) const;

    int store2hole(int store) const;
    int hole2store(int hole) const;
    int hole2house(int hole) const;
    int house2hole(int house) const;
    
    Half getHalf(int hole) const;
    bool isHalfEmpty(Half half) const;

private:

    int store1_;
    int store2_;
    std::vector<int> board_;

    bool checkRange (int hole) const;
};

#endif
