#ifndef _GAME_H_
#define _GAME_H_

#include <string>
#include <memory>

#include "IGame.h"
#include "Player.h"
#include "Board.h"

class IEngine;

class Game : public IGame
{
public:
    Game(IEngine * engine, int houses = 12, int seeds = 3);

    void player1(std::string name, bool user);
    void player2(std::string name, bool user);
    
    virtual bool isFinished() const;
    virtual std::string getWinner() const;
    virtual std::string getActivePlayerName() const;
    virtual std::string getPlayer1Name () const;
    virtual std::string getPlayer2Name () const;

    virtual bool makeMove( int house );
    virtual int getSeedsInHouse( int house ) const;
    virtual int getSeedsInStorage( int storage ) const;
    
private:
    std::auto_ptr<IEngine> engine_;
    Player * player1_;
    Player * player2_;
    Player * activePlayer_;
    Board board_;
    bool finished_;

//    void updateState (int latestEndHoleId, Board::HoleType latestEndHoleType);
};

    

#endif
