#ifndef _IENGINE_H_
#define _IENGINE_H_

class Player;
class Board;

class IEngine
{
public:
    enum MoveResult {
        INVALID_MOVE,
        VALID_MOVE_CHANGE_TURN,
        VALID_MOVE_EXTRA_TURN,
        VALID_MOVE_GAME_FINISHED
    };

    virtual ~IEngine() { }
    
    virtual MoveResult makeMove (const Player * player, Board * board, int house) = 0;
    virtual Player * getWinner (Player * p1, Player * p2, const Board * board) const = 0;
};

#endif
